using System;
using System.Collections;
using System.ComponentModel;

namespace bindingclass_test
{
	/// <summary>
	/// Summary description for CollectionClass1.
	/// </summary>
	public class CollectionClass1 : System.Collections.CollectionBase ,System.ComponentModel.IBindingList
	{
	
		private ListChangedEventArgs resetEvent = new ListChangedEventArgs(ListChangedType.Reset, -1);
		private ListChangedEventHandler onListChanged;

		public CollectionClass1()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public Class1 this[int index] 
		{
			get 
			{
				return (Class1)(List[index]);
			}
			set 
			{
				List[index] = value;
			}
		}

		public int Add (Class1 value) 
		{
			return List.Add(value);
		}

		public Class1 AddNew() 
		{
			return (Class1)((IBindingList)this).AddNew();
		}

		public void Remove (Class1 value) 
		{
				
		
			List.Remove(value);
			
		}
		public new void  RemoveAt (int i) 
		{
				
			List.RemoveAt(i);
			
		}

    
		protected virtual void OnListChanged(ListChangedEventArgs ev) 
		{
			if (onListChanged != null) 
			{
				onListChanged(this, ev);
			}
		}
    

		protected override void OnClear() 
		{
			foreach (Class1 c in List) 
			{
				
				c.Parent = null;
			}
		}

		protected override void OnClearComplete() 
		{
			OnListChanged(resetEvent);
		}

		protected override void OnInsertComplete(int index, object value) 
		{
			Class1 c = (Class1)value;
			c.Parent = this;
			OnListChanged(new ListChangedEventArgs(ListChangedType.ItemAdded, index));
		}

		protected override void OnRemoveComplete(int index, object value) 
		{
			Class1 c = (Class1)value;
			c.Parent = this;
			OnListChanged(new ListChangedEventArgs(ListChangedType.ItemDeleted, index));
		}

		protected override void OnSetComplete(int index, object oldValue, object newValue) 
		{
			if (oldValue != newValue) 
			{

				Class1 oldcust = (Class1)oldValue;
				Class1 newcust = (Class1)newValue;
            
				oldcust.Parent = null;
				newcust.Parent = this;
            
            
				OnListChanged(new ListChangedEventArgs(ListChangedType.ItemAdded, index));
			}
		}
    
		// Called by Class1 when it changes.
		internal void Class1Changed(Class1 cust) 
		{
        
			int index = List.IndexOf(cust);
        
			OnListChanged(new ListChangedEventArgs(ListChangedType.ItemChanged, index));
		}
		//*******************************************************************************************************
		// Implements IBindingList.
		
		bool IBindingList.AllowEdit 
		{ 
			get { return true ; }
		}

		bool IBindingList.AllowNew 
		{ 
			get { return true ; }
		}

		bool IBindingList.AllowRemove 
		{ 
			get { return true ; }
		}

		bool IBindingList.SupportsChangeNotification 
		{ 
			get { return true ; }
		}
    
		bool IBindingList.SupportsSearching 
		{ 
			get { return false ; }
		}

		bool IBindingList.SupportsSorting 
		{ 
			get { return false ; }
		}


		// Events.
		public event ListChangedEventHandler ListChanged 
		{
			add 
			{
				onListChanged += value;
			}
			remove 
			{
				onListChanged -= value;
			}
		}

		// Methods.
		object IBindingList.AddNew() 
		{
			Class1 c = new Class1();
			List.Add(c);
			return c;
		}


		// Unsupported properties.
		bool IBindingList.IsSorted 
		{ 
			get { throw new NotSupportedException(); }
		}

		ListSortDirection IBindingList.SortDirection 
		{ 
			get { throw new NotSupportedException(); }
		}


		PropertyDescriptor IBindingList.SortProperty 
		{ 
			get { throw new NotSupportedException(); }
		}


		// Unsupported Methods.
		void IBindingList.AddIndex(PropertyDescriptor property) 
		{
			throw new NotSupportedException(); 
		}

		void IBindingList.ApplySort(PropertyDescriptor property, ListSortDirection direction) 
		{
			throw new NotSupportedException(); 
		}

		int IBindingList.Find(PropertyDescriptor property, object key) 
		{
			throw new NotSupportedException(); 
		}

		void IBindingList.RemoveIndex(PropertyDescriptor property) 
		{
			throw new NotSupportedException(); 
		}

		void IBindingList.RemoveSort() 
		{
			throw new NotSupportedException(); 
		}



	}
}

		
		
		
		
		
	
		

		
	